


;                             INIZIALIZZAZIONE
;                             ----------------

        .title  "termostato"

	.vers   "ST62E65"      
	.w_on			;abilitazione data rom window


;****************************************************************************
;*                       VARIABILI DEL MICRO                                *
;****************************************************************************


;      DEFINIZIONE DEGLI INDIRIZZI DI PARTENZA DELLE VARIE AREE DI MEMORIA
;      -------------------------------------------------------------------



;            DEFINIZIONE DELLE LOCAZIONI DEI 5 REGISTRI DEL MICRO
;            ----------------------------------------------------

a       .def    0ffh    ;ACCUMULATOR (REGISTRO ACCUMULATORE)
x       .def    080h    ;X REGISTER  (REGISTRO X)
y       .def    081h    ;Y REGISTER  (REGISTRO Y)
v       .def    082h    ;V REGISTER  (REGISTRO V)
w       .def    083h    ;W REGISTER  (REGISTRO W)


;              DEFINIZIONE DEI REGISTRI DELLE PORTE
;              ------------------------------------

port_a  .def    0c0h    ;PORT A DATA REGISTER
port_b  .def    0c1h    ;PORT B DATA REGISTER
port_c  .def    0c2h    ;PORT C DATA REGISTER
pdir_a  .def    0c4h    ;PORT A DIRECTION REGISTER  (0=Input   1=Output)
pdir_b  .def    0c5h    ;PORT B DIRECTION REGISTER
pdir_c  .def    0c6h    ;PORT C DIRECTION REGISTER
popt_a  .def    0cch    ;PORT A OPTION REGISTER
popt_b  .def    0cdh    ;PORT B OPTION REGISTER
popt_c  .def    0ceh    ;PORT C OPTION REGISTER


;               DEFINIZIONE DEL REGISTRO DEGLI INTERRUPT
;               ----------------------------------------

ior     .def    0c8h    ;INTERRUPT OPTION REGISTER.


;               DEFINIZIONE DEL REGISTRO PER IL CONVERTITORE A/D
;               ------------------------------------------------

addr    .def    0d0h    ;A/D DATA REGISTER (REGISTRO DATI DEL CONVERTITORE)
adcr    .def    0d1h    ;A/D CONTROL REGISTER (REGISTRO DI CONTROLLO)


;               DEFINIZIONE DEI REGISTRI DEL TIMER1
;               -----------------------------------

psc     .def    0d2h    ;TIMER PRESCALER REGISTER (REGISTRO DEL PRESCALER)
tcr     .def    0d3h    ;TIMER DATA REGISTER (REGISTRO DATI)
tscr    .def    0d4h    ;TIMER TSCR REGISTER ( REGISTRO PER IL CONTROLLO
			;DELLO STATO DEL TIMER)

;               OSCILLATORE
;               -----------

oscr	.def	0dch	;OSCILLATOR CONTROL REGISTER

;                TIMER2
;                ------

mc	.def	0d5h	;TIMER2 MODE CONTROL REGISTER
sc0	.def	0d6h	;TIMER2 STATUS CONTROL REGISTER
sc1	.def	0d7h	;TIMER2 STATUS CONTROL REGISTER
rc	.def	0d9h	;TIMER2 RELOAD/CAPTURE REGISTER
cp	.def	0dah	;TIMER2 COMPARE REGISTER
lr	.def	0dbh	;TIMER2	LOAD REGISTER

;		EEPROM
;		------

eecr	.def	0eah	;EEPROM CONTROL REGISTER

;		REGISTRI SERIALE
;		----------------

lvi	.def	0ddh	;MULTIPLEX REGISTER/LVI FLAG REGISTER
spidsr	.def	0e0h	;SPI REGISTER DSR
spidiv	.def	0e1h	;SPI REGISTER DIV
spimod	.def	0e2h	;SPI REGISTER MOD

;		BANCO MEMORIA
;		-------------

dramwr  .def    0e8h    ;MEMORY BANK REGISTER

;		EQUATES DEFINITION
;		------------------

;memoria variabili disponibile da 084H a 0BFH 


chr1    .def    084h     ; 1 cifra disp
chr2    .def    chr1+1   ; 2
chr3    .def    chr2+1   ; 3
chr4    .def    chr3+1   ; 4
var1    .def    chr4+1
var2    .def    var1+1   

savex   .def    var2+1   ;
savey   .def    savex+1  ;
kk      .def    savey+1  ;
zz      .def    kk+1     ;
copy    .def    zz+1     ;            
savea   .def    copy+1   ;
safea   .def    savea+1
;punti   .def    safea+1
;ore     .def    punti+1
;minuti  .def    ore+1
;secondi .def    minuti+1
cent    .def    safea+1
unita   .def    cent+1
decine  .def    unita+1
centinaia .def  decine+1
value   .def    centinaia+1
;orex    .def    value+1
;minx    .def    orex+1
counter .def    value+1
dat     .def    counter+1
timing  .def    dat+1
clock   .def    timing+1
flag    .def    clock+1
freq    .def    flag+1
zz1     .def    freq+1
count   .def    zz1+1
zz2     .def    count+1
timcrc  .def    zz2+1
msflag  .def    timcrc+1
period  .def    msflag+1
savex1  .def    period+1
savea1  .def    savex1+1
prd_mig .def    savea1+1
prd_dec .def    prd_mig+1
aver_hi .def    prd_dec+1
aver_lo .def    aver_hi+1
number_a.def    aver_lo+1
number_b.def    number_a+1
result  .def    number_b+1
remaind .def    result+1
set_temp.def    remaind+1
time_o1 .def    set_temp+1
time_o2 .def    time_o1+1
flash   .def    time_o2+1
wndw    .def    flash+1
t_on    .def    wndw+1
t_off   .def    t_on+1
t_real  .def    t_off+1








;		MACROFUNCTIONS DEFINITION
;                  -------------------
;***************************************************************************
;_________________________ M A C R O S _____________________________________
;***************************************************************************

;*********************************************end of macros****************



;               DEFINIZIONE DEL REGISTRO PER IL WATCH-DOG
;               -----------------------------------------

wdog    .def    0d8h    ;WATCHDOG REGISTER


;              DEFINIZIONE DEL REGISTRO PER LO SPAZIO DATI ROM
;              -----------------------------------------------

drw     .def    0c9h    ;DATA ROM WINDOW REGISTER

;****************************************************************************
;*                         VARIABILI DEL PROGRAMMA                          *
;****************************************************************************




;****************************************************************************
;*                         SETTAGGIO INIZIALE                               *
;****************************************************************************



;             INIZIO DEL PROGRAMMA
;             --------------------

	.org    080h   	


                                                     
               


inizio                  ;  INIZIALIZZAZIONE DELLE PERIFERICHE


	ldi     wdog,0ffh       ; RICARICA IL WATCH DOG

;      SETTAGGIO DELLA PORTA "A" 
;      -------------------------
        ldi     port_a,00000000b        ;input no pull up
        ldi     pdir_a,11111111b
        ldi     popt_a,11111111b

;      SETTAGGIO DELLA PORTA "B"
;      -------------------------
        ldi     port_b,00000000b        ;output push pull
        ldi     pdir_b,11111111b        ;pb0 to pb6
        ldi     popt_b,11111111b        ;pb7 input pull up

;      SETTAGGIO DELLA PORTA "C"
;      -------------------------
        ldi     port_c,00000001b
        ldi     pdir_c,00000000b        ;PC0 analog input        
        ldi     popt_c,00000001b        

;pcinte  .equ    00011001b               ;costante corrisp. int abilit port_c
;pcintd  .equ    00000001b               ;costante corrisp. int disab. port_c


	ldi     adcr,40h        ;A/D IN STANDBY
	ldi     tscr,0         	;DISABLE TIMER INTERRUPT
	ldi     ior,00010000b  	;ENABLE ALL INTERRUPT

	ldi	oscr,0		;fint=fosc
	ldi	eecr,0		;eeprom disabled
	ldi	mc,0		;ar timer stopped
	ldi	sc0,0
	ldi	sc1,0
	ldi	cp,0



	reti    		;RIPRISTINA I FLAG PRINCIPALI


	jp      main		;SALTA AL PROGRAMMA PRINCIPALE


;****************************************************************************
;*                       SUBROUTINE DI INTERRUPT                            *
;****************************************************************************


ad_int                  ;INTERRUPT DEL CONVERTITORE A/D E DEL TIMER 1  

	reti				;125 fine della routine di interrupt



tim_int                 ;INTERRUPT DEL TIMER 2 (A/R TIMER)
	reti



CSPI_int                ;INTERRUPT DELLE PORTE   C e SPI
        
	reti

A_int                   ;INTERRUPT DELLA PORTA A e B

	reti

nmi_int                 ;INTERRUPT NON MASCHERABILE
                               
	reti


;****************************************************************************
;*                         SUBROUTINE                                       *

;***************************************************************************
;                             DIVISION SUBROUTINE 8bit
;***************************************************************************

; Initialize registers and save the contexte.

division
         ld savea,a               ; save the accumulator.
         clr result               ; clear the result register.
         clr remaind              ; clear the remainder register.

; Test A and B in order to enable the division subroutine.

         ld a,number_b            ; B = 0 then the result = 0 ( not valid ).
         jrnz div0            
end_div         
         ld a,savea               ; restore the accumulator.
         ret




div0     ld a,number_a            ; A = 0 then the result = 0.
         jrz end_div

; Division subroutine.

         addi a,0FFh              ; clear the carry.
         ldi counter,08h          ; load the shift counter.
         ld a,number_a            ; \
         rlc a                    ;  | rotate left and save in result register.
         ld result,a              ; /
div1     ld a,remaind             ; \
         rlc a                    ;  | rotate left the remainder register in
         ld remaind,a             ; /  order to include the carry.
         sub a,number_b
         jrc div2                 ; test if the subtraction is valid.
         ld remaind,a 
div2     ld a,result              ; \
         rlc a                    ;  | rotate left the result register.
         ld result,a              ; /
         dec counter
         jrz div3
         jp div1
div3     com a                    ; complement the result.
         ld result,a
         jp end_div
;***************************************************************************



;***************************CONVERSIONE A/D*********************************
;                       (AVERAGED SAMPLE MODE)

average	ldi	wdog,255
	clr	aver_lo
	clr	aver_hi
	ldi	count,255
aver1
	call	convert		;chiama la conversione a/d

	add	a,aver_lo
	jrnc	aver2
	inc	aver_hi
aver2	ld	aver_lo,a

	ld	a,count
	jrz	aver4
	dec	count
	jp 	aver1
aver4	ld	a,aver_lo
	cpi	a,127
	jrc	aver3
	inc 	aver_hi
aver3	ld	a,aver_hi
	ld	value,a
        ret

convert                         ;subroutine conversione a/d
	ldi     wdog,255        ;ricarica wdog
	ldi     adcr,00110000b  ;provvedi a convertire a/d
attendi jrr     6,adcr,attendi  ;attende conversione
	ld      a,addr          ;carica in a a/d
	ret                     ;ritorna alla chiamata

;****************************************************************************
;******************************************************************************
;*              E E P R O M   R E A D                                         *
;******************************************************************************
;******************************************************************************

eepr           ;x=locazione da leggera a=dato
                ldi     dramwr,1            ; SELECT PAGE 0 OF EEPROM
busyr           jrs     1,eecr,busyr        ; BUSY ?
                ld      a,(x)               ; READ DATA
                ldi     dramwr,0
                ret

;==============={END OF EEPROM READ ROUTINE}===================================


;******************************************************************************
;*              E E P R O M   W R I T E                                       *
;******************************************************************************
;******************************************************************************

eepw           ; (x=locazione a=data)
                ldi     dramwr,1            ; SELECT PAGE 0 OF EEPROM
busyw1          jrs     1,eecr,busyw1       ; BUSY ?
                ldi     eecr,00000001b      ; ENABLE EEPROM WRITE
                ld      (x),a               ; WRITE DATA
busyw2          jrs     1,eecr,busyw2       ; BUSY ?
                ldi     eecr,00000000b      ; DISABLE EEPROM WRITE
                ldi     dramwr,0            ;reselect RAM
                ret



;****************************************************************************
;		SUBROUTINE PER RITARDI BREVI
;****************************************************************************


;mc 1.625microsec.  @ 8Mhz



k_micros

;               ROUTINE RITARDO IN MIGLIAIA DI MICROSECONDI
;               ___________________________________________
;
;       il valore  prd_mig che indica le migliaia di microsec di ritardo
;       non viene influenzato.
;       ES. funzionamento:      prd_mig=125 genera un ritardo di 125000 micro




        ld      a,prd_mig               ;4 cicli macchina
        ld      count,a                 ;4



del_a   ldi     zz1,60                  ;4   ;per ottener 1000 microsec

del_b   ldi     wdog,255                ;4   ]
        dec     zz1                     ;4   ]---- pari a 10 cicli=16.25 
        jrnz    del_b                   ;2   ]


        dec     count                   ;4   ;decrementa le migliaia   
        jrnz    del_a                   ;2   ;fino a che non finiscono




        ld      a,prd_dec               ;4
        jrz     enddel                  ;2
        ld      count,a                 ;4


del_d   ldi     wdog,255                ;4    ]
        dec     count                   ;4    ]---- pari a 10 cicli=16.25
        jrnz    del_d                   ;2    ]

                     

enddel  ret












;*********************************************************************
binbcd	ldi	wdog,255	;ricarica wdog
        ldi     centinaia,0     ;azzera il byte centinaia
	ldi	decine,0		;azzera il byte decine
        ldi     unita,0         ;azzera il byte unita
binbcd1 ld      a,value         ;carica in accumulatore il byte da conv.
	cpi	a,0		;compara e se diverso da 0
	jrnz	step1		;salta a step1
	ret			;altrimenti torna dalla chiamata
step1   dec     value           ;decremente di una unita il byte da conv.
        inc     unita           ;incrementa di uno il byte delle unita
        ld      a,unita         ;carica in accumulatore il byte unita
	cpi	a,10		;e se minore di 10  
	jrc	step2		;salta a step2 ricominciando

        ldi     unita,0         ;altrimenti lo pone a 0
	inc	decine		;e incrementa il byte delle decine
	ld	a,decine	;lo carica nell'accumulatore
	cpi	a,10		;e lo compara con 10
	jrc	step2		;se minore salta a step2 ricominciando

	ldi	decine,0	;altrimenti lo pone a 0
	inc	centinaia	;ed incrementa le centinaia

step2	jp	binbcd1		;salta a binbcd1
	ret


     

dsp_clr ;ld      savea,a         ;ACC safe
        ;ld      a,port_a        ;copy from port_a
                                 ;___
        res     0,port_a        ;clr=0
               
        ;ld      port_a,a        ;copy  to  port_a
        nop                     ;nop
                                ;___
        set     0,port_a        ;clr=1
        ;ld      port_a,a        ;copy  to  port_a
        ;ld      a,savea         ;ACC restore
        ret

;dspch_e ld      savea,a         ;ACC safe
;        ld      a,port_a        ;copy from port_a
;                                ;__
;        set     1,a             ;cu=0
;        ld      port_a,a        ;copy to port_a
;        ld      a,savea         ;ACC restore
;        ret

dspch_d ld      savea,a         ;ACC safe
;        ld      a,port_a        ;copy from port_a
;                                ;__
;        res     1,port_a        ;cu=1
;        ld      port_a,a        ;copy  to  port_a
;        ld      a,savea         ;ACC restore
        ret
        
;_________________________________ROUTINE VISUALIZZAZIONE SU DISPLAY
wr_go   res     7,port_b
        set     7,port_b
        ret
                

adr_dsp ;ld      savea,a
        ld      a,x
        subi    a,84h
        jrnz    nx1
        res     1,port_a
        res     2,port_a
       ; ld      a,savea
        ret
nx1     cpi     a,1
        jrnz    nx2
        set     1,port_a
        res     2,port_a
        ;ld      a,savea
        ret
nx2     cpi     a,2
        jrnz    nx3
        res     1,port_a
        set     2,port_a
        ;ld      a,savea
        ret
nx3     cpi     a,3
        jrnz    nx4
        set     1,port_a
        set     2,port_a

nx4     ;ld      a,savea
        ret






disp
;        call    dspch_e         ;abilita memoria display
        ldi     x,084h
wrd1    ld      a,(x)           ;passa in ACC contenuto chr1
        set     7,a             ;tiene alto bit 7 (WR)
        ld      port_b,a        ;passa i dati in port_a
        call    adr_dsp         ;indirizzo cifra display
        call    wr_go           ;wr pulse
        inc     x
        ld      a,x
        cpi     a,088h
        jrz     enddsp
        jp      wrd1
enddsp  ret
;___________________________________________________________________

mode_chg
        ldi     chr1,01011111b
        ldi     chr2,01011111b
        ldi     chr3,01011111b
        ldi     chr4,01011111b
        call    disp
        ret



ascii   
        ld      a,chr1
        addi    a,30h
        ld      chr1,a
        ld      a,chr2
        addi    a,30h
        ld      chr2,a
        ld      a,chr3
        addi    a,30h
        ld      chr3,a
        ld      a,chr4
        addi    a,30h
        ld      chr4,a
        ret
ascii2  
       ;ld      a,chr1
       ;addi    a,30h
        ldi     chr1,00011011b ;(simbolo centigradi)
        ld      a,chr2
        addi    a,30h
        ld      chr2,a
        ld      a,chr3
        addi    a,30h
        ld      chr3,a
;       ld      a,chr4
;       addi    a,30h
        ldi     chr4,00100000b ;(carattere nullo)

        jrr     6,flag,nprg     ;se il bit 2 e' settato modo window
        jp      wprg

nprg    jrr     7,flag,nostem  ;se bit 7 flag off va a nostem
        ldi     chr4,00000010b ;altrimenti visualizza la freccia di impost
        ret                    ;e termina
nostem  jrs     0,flag,actmk   ;se flag 1 on va a actmk (mark attivo)
        ldi     chr4,00101111b ;altrimenti mostra il carattere di spento
        ret                    ;e termina
actmk   ldi     chr4,01011110b ;visualizza carattere di acceso
        jrr     1,flag,actmkf1 ;se il bit 1 del flag e' 0 non lampeggia

        dec     flash
        jrnz    actmkf1
        ldi     chr4,00100000b ;chr nullo
        ldi     flash,4

actmkf1
        ret                    ;termina



wprg    ldi     chr4,01010111b
        ret

show    ld      a,timing
        ld      value,a
	call	binbcd			;111 converte in BCD
        ldi     chr4,0
        ld      a,centinaia
        ld      chr3,a
        ld      a,decine                ;112 copia in a il numero di destra
        ld      chr2,a                  ;113 copia in bcd2 l'accumulatore
        ld      a,unita                 ;114 copia in a il numero di sinistra
        ld      chr1,a                  ;115 copia in bcd1 l'accumulatore
        call    ascii                   ;122 chiama la routine segm
        call    disp

        ret





showtemp
        ld      a,timing
        ld      value,a
        call binbcd              ;111 converte in BCD
        ldi     chr4,0
        ld      a,decine   
        ld      chr3,a
        ld      a,unita                 ;112 copia in a il numero di destra
        ld      chr2,a                  ;113 copia in bcd2 l'accumulatore

;       ld      a,unita                 ;114 copia in a il numero di sinistra
;       ld      chr1,a                  ;115 copia in bcd1 l'accumulatore

        call    ascii2               ;122 chiama la routine segm
        call    disp
        call    k_micros
        ret

setting ldi     wdog,255


        jrs     4,port_c,nodown         ;gestione pulsante -
        ld      a,set_temp              ;
        subi    a,5                     ;sottrae di 5 in 5
        ld      set_temp,a              ;
        jp      reald                   ;salta a reald

nodown  jrs     3,port_c,noup           ;gestione pulsante +

        ld      a,set_temp              ;
        addi    a,5                     ;addiziona di 5 in 5
        ld      set_temp,a              ;

        jp      reald                   ;salta a reald per aggiorn.display

noup    jp      noreds

reald
        ldi     time_o1,255             ;impostazione/timeout
        ldi     time_o2,180
        ld      a,set_temp               ;limita il valore impostabile
        cpi     a,255                   ;max 250
        jrz     frz_max                 ;(5 valori oltre lo impone)
        cpi     a,0
        jrz     frz_min                 ;min  10
        jp      ok_lim                  ;(5 valori sotto lo impone)

frz_max ldi     set_temp,250            ;se 255 pone a 250
        jp      ok_lim
frz_min ldi     set_temp,5              ;se 0 pone a 5 
        jp      ok_lim



ok_lim  ld      a,set_temp              
        ld     number_a,a
        ldi    number_b,5
        call   division                 ;provvede a convertire il valore
                                        ;impostato in centigradi
        ld     a,result

        ld     timing,a
        set     7,flag                  ;flag di impostazione temp.
        
        call    showtemp                ;lo mostra sul display in formato
                                        ; _XXC*

        ld      a,set_temp
        ldi     x,1                     ;locazione 1=temp impostata
        call    eepw                    ;

        call    rel_but
noreds  res     7,flag                  ;resetta il flag di imp temp.
        ret


rel_but ldi     wdog,255                ;rilascio pulsanti (antirimb.)
        jrr     3,port_c,rel_but        ; up & down
        jrr     4,port_c,rel_but        
        ret



;***************************************************************************
;***************************************************************************
;*                         PROGRAMMA PRINCIPALE                            *
;***************************************************************************
;****************************************************************************

;FLAG STATUS:
; bit 0 controllo temperatura 1=abilitato 0=disabilitato
; bit 1 carico 1=acceso 0=spento
; bit 7 impostazione temp.    1=variazione 0=stabilita
; bit 6 window program 1=impostazione finestra 2=finestra impostata

;eeprom
;locazione 1 temperatura impostata
;locazione 2 status flag
;locazione 3 window width temperatura


main    ldi     wdog,255        ;INIZIALIZZAZIONE DISPLAY
        set     7,port_b        ;pone wr alto
        call    dsp_clr         ;pulisce display e inizializza
        call    dspch_d
        ldi     port_b,10001000b;
        call    wr_go
        clr     flag
        clr     t_real
        clr     wndw
        ldi     flash,10

        ldi     x,1
        call    eepr
        ld      set_temp,a      ;richiama da eeprom temp. impostata
        ld     number_a,a       ;verifica sia divisibile per 5
        ldi    number_b,5       ;senza resto
        call   division         ;
        ld      a,remaind       ;
        jrz     ok_val1         ;se divisibile vai a ok_val1
        ldi     x,1             ;altrimenti memorizza 100
        ldi     a,100           ;nella pos. eeprom
        call    eepw            ;e riesegue il boot
        jp      main            ;

ok_val1


;        ldi     x,2
;        call    eepr
;        ld      flag,a         ;richiama da eeprom status flag




        ldi     x,3
        call    eepr
        ld      wndw,a          ;richiama da eeprom window impostata

ag      ldi     prd_mig,255
        call    mode_chg


        call    k_micros
        call    k_micros
        call    k_micros
        call    k_micros

        jrr     3,port_c,wndp1          ;verifica se preme rosso
        call    k_micros                 ;attendi
wndp1   jrs     4,port_c,stmp           ;verifica se preme nero


        jp      wndprg                  ;se preme nero va a wndprg

stmp    call    ok_lim                  ;altrimenti prosegue

        ldi     time_o1,255
        ldi     time_o2,180    ;carica il timer di set temperatura
ag1     
        call    setting         ;chiama la sub di impostazione temperatura
        dec     time_o1
        jrz     tim1
        jp      ag1

tim1    ldi     time_o1,255
        dec     time_o2
        jrnz    ag1



again

;=
        jrr    3,port_c,pr1     ;verifica se premuto il tasto rosso
        jp     nopro            ;se rilasciato va a nopro (nessuna program)
pr1
        ldi    prd_mig,100
        call   k_micros

        jrr    4,port_c,ag      ;se arriva qui premuto rosso, se premuto anche
                                ;il nero va a ag
                                ;
        clr     flag            ;
        set     0,flag           ;altrimenti solo rosso setta 0 di flag
                                 ;sistema di regolazione attivo
;        ldi     x,2              ;locazione 2 per il flag
;        ld      a,flag           ;flag in acc.
;        call    eepw             ;scrive eeprom


nopro   jrs     4,port_c,nopro1 ;
        clr     flag
        res     0,flag
;        ldi     x,2
;        ld      a,flag
;        call    eepw



nopro1  call   average
        ld     t_real,a
        ld     number_a,a
        ldi    number_b,5
        call   division

        ld      a,result

        ld     timing,a
        call    showtemp

        ld      a,set_temp      ;passa in acc valore temp impostato
        add     a,wndw          ;aggiunge all'acc il valore di window
        ld      t_off,a         ;passa in variabile t_off (temp di spegn.)
        ld      a,set_temp      ;passa in acc valore temp impostato
        sub     a,wndw          ;sottrae all'acc il valore di window
        ld      t_on,a          ;passa in variabile t_on (temp di acc.)

        ld      a,t_real        ;passa in acc. valore temp. (raw)
        cp      a,t_off         ;compara con la temperatura di spegn.
        jrnc    ld_off          ;se maggiore o uguale spegne il carico

        ld      a,t_real
        dec     a               ;per simmetria (jrnc >= mentre jrc solo < )
        cp      a,t_on          ;compara con temperatura di accensione
        jrc     ld_on           ;se temp. minore di t_on accende  
        jrr     0,flag,ld_off   ;se bit 0 del flag = 0 non regolare la temp
        jp      again

ld_off  res     1,flag          ;resetta il bit 1 del flag
        res     7,port_a        ;spegne il carico
        jp      again
ld_on   jrr     0,flag,ld_off   ;se bit 0 del flag=0 non regola la temp
        set     1,flag          ;setta il bit 1 del flag
        set     7,port_a        ;accende il carico
        jp      again
          

wndprg  call    k_micros
        jrr     3,port_c,wndprg
        jrr     4,port_c,wndprg


        ldi     x,3
        call    eepr
        ld      wndw,a
        call    k_micros

        ldi     time_o1,255
        ldi     time_o2,40    ;carica il timer di set temperatura
        jp      ok_lim1
wndprg1
        jrs     4,port_c,nodown1        ;gestione pulsante -
        dec     wndw
        jp      reald1                   ;salta a reald

nodown1 jrs     3,port_c,noup1          ;gestione pulsante +
        inc     wndw

        jp      reald1                   ;salta a reald per aggiorn.display

noup1   jp      noreds1

reald1
        ldi     time_o1,255
        ld      a,wndw                  ;limita il valore impostabile
        cpi     a,11                    ;max 10
        jrnc    frz_max1                 ;(5 valori oltre lo impone)
        cpi     a,1
        jrc     frz_min1                 ;min  0
        jp      ok_lim1                  ;(5 valori sotto lo impone)

frz_max1
         ldi     wndw,10            ;limiti wndw
         jp      ok_lim1
frz_min1
         ldi     wndw,1              ;limiti wndw
        jp      ok_lim1

ok_lim1                
        ld      a,wndw
        sla     a
        sla     a
        ld     timing,a
        clr     flag

        set     6,flag                  ;flag di impostazione win
        
        call    showtemp                ;lo mostra sul display in formato
                    
        call    rel_but
noreds1 res     6,flag                  ;resetta il flag di imp win

        dec     time_o1
        jrz     end1p
        jp      wndprg1

        nop
        nop
        nop

end1p   ldi     time_o1,255
        call    k_micros
        dec     time_o2
        jrz     rstall
        jp      wndprg1

rstall

        ld      a,wndw
        ldi     x,3
        call    eepw
        call    k_micros
        jp      again



;.ifc    ne ($%64)
;        .block  64-$%64
;.endc

;dlut    .byte   048,007,047,061,047,016,046,072                            
;        .byte   046,029,045,087,045,045,045,004                        
;        .byte   044,064,044,024,043,085,043,047                    
;        .byte   043,010,042,073,042,037,042,001
;        .byte   041,066,041,032,040,098,040,065
;        .byte   040,032,040,000,039,068,039,037
;        .byte   039,006,038,075,038,046,038,016
;        .byte   037,087,037,059,037,031,037,003





;*                     VETTORI DI INTERRUPTS                     *
;****************************************************************************


	.org    0ff0h
	jp      ad_int  ; A/D & TIMER1		     vector #4
	jp      tim_int ; AR    TIMER                vector #3
	jp      CSPI_int;INTERRUPT PORTE C e spi     vector #2
	jp      A_int   ;INTERRUPT PORTA A e B       vector #1
	.org    0ffch
	jp      nmi_int ;INTERRUPT NON MASCHERABILE  vector #0
	jp      inizio  ;INTERRUZIONE PER IL SETTAGGIO INIZIALE

;*****************************************************************************

	.end                    ; Termine del programma







